#include "paging.h"

bool Paging::reserve(fileid_t fileid)
{
    _lock.lock();

    return _mappers.find(fileid) != _mappers.end();
}

PageMapper *Paging::get(fileid_t fileid)
{
    FileMapping::iterator entry = _mappers.find(fileid);
    PageMapper *mapper;

    if (entry == _mappers.end())
        mapper = NULL;
    else
        mapper = entry->second;

    _lock.unlock();
    return mapper;
}

void Paging::set(fileid_t fileid, PageMapper *mapper)
{
    FileMapping::iterator entry = _mappers.find(fileid);

    if (entry == _mappers.end())
        _mappers[fileid] = mapper;

    _lock.unlock();
}

// vim: tabstop=4 expandtab shiftwidth=4
