#pragma once

#include <map>
#include <mutex>

#include "page_mapper.h"



/* Mapping type from accessors to page mappers. */

typedef std::map<fileid_t, PageMapper *> FileMapping;
typedef std::pair<fileid_t, PageMapper *> FileMappingEntry;



/* A registry of mappers for accessors. */

class Paging
{
protected:
    FileMapping _mappers;
    std::mutex _lock;

public:
    bool reserve(fileid_t fileid);

    PageMapper *get(fileid_t fileid);

    void set(fileid_t fileid, PageMapper *mapper);
};

// vim: tabstop=4 expandtab shiftwidth=4
